extends Node

# 再生にセットされたテキストファイル
var current_story = ""

# Signals - Main
signal node
signal audio_bgm
signal audio_se

# Images
var bg1 = preload("res://Images/bg1.png")
var bg2 = preload("res://Images/bg2.png")
var front = preload("res://Images/front.png")
var chara1 = preload("res://Images/chara1.png")
var chara2 = preload("res://Images/chara2.png")
var chara3 = preload("res://Images/chara3.png")
var emote_ex = preload("res://Images/emote_ex_left.png")
var emote_heart = preload("res://Images/emote_heart_left.png")
var emote_q = preload("res://Images/emote_q_left.png")

# Sounds - BGM
var bgm1 = preload("res://Sounds/BGM/bgm1.ogg")
# Sounds - SE
var se_pon = preload("res://Sounds/SE/se_pon.ogg")

func get_scene(name):
	match name:
		"start":
			var start = preload("res://Scenes/Start.tscn").instance()
			return start
		"story":
			var story = preload("res://Scenes/Story.tscn").instance()
			return story
	return null

func get_image(name):
	match name:
		"bg1":
			return bg1
		"bg2":
			return bg2
		"front":
			return front
		"chara1":
			return chara1
		"chara2":
			return chara2
		"chara3":
			return chara3
		"ex":
			return emote_ex
		"heart":
			return emote_heart
		"q":
			return emote_q
		_:
			return null

func get_bgm(name):
	match name:
		"bgm1":
			return bgm1
		_:
			return null

func get_se(name):
	match name:
		"pon":
			return se_pon
		_:
			return null
