extends "res://Scripts/StoryLib.gd"

onready var bgm : = $BGM
onready var bgm_mirror : = $BGMMirror
onready var se : = $SE

func _ready():
	Data.connect("node", self, "_node")
	Data.connect("audio_bgm", self, "_audio_bgm")
	Data.connect("audio_se", self, "_audio_se")
	_node("start", true)

# インスタンスシーンを開く(name = シーンの先頭にあるノード名)
func _node(name, is_open):
	var scene = Data.get_scene(name)
	
	if is_open:
		add_child(scene)
		
		if scene == Data.get_scene("story"):
			Data.emit_signal("ready_story")
	else:
		if scene != null && has_node(name):
			scene.queue_free()

# BGMコントロール
# フェードはフェードアウトのみ
func _audio_bgm(title, is_play, is_fadeout):
	if is_play && title != null:
		bgm_mirror.set_stream(Data.get_bgm(title))
		
		# BGM停止中または同じ曲でなければ最初から再生する
		if (bgm.get_stream() != bgm_mirror.get_stream()) || !bgm.playing:
			bgm.set_volume_db(0)
			bgm.set_stream(Data.get_bgm(title))
			bgm.playing = true
	elif !is_play: # stop
		if is_fadeout:
			bgm.set_volume_db(-5)
			yield(get_tree().create_timer(0.25), t)
			bgm.set_volume_db(-10)
			yield(get_tree().create_timer(0.25), t)
			bgm.set_volume_db(-15)
			yield(get_tree().create_timer(0.25), t)
			bgm.set_volume_db(-20)
			yield(get_tree().create_timer(0.25), t)
			bgm.set_volume_db(-25)
			yield(get_tree().create_timer(0.25), t)
			bgm.set_volume_db(-30)
			yield(get_tree().create_timer(0.25), t)
			bgm.set_volume_db(-35)
			yield(get_tree().create_timer(0.25), t)
			bgm.set_volume_db(-40)
			yield(get_tree().create_timer(0.25), t)
			bgm.set_volume_db(-45)
			yield(get_tree().create_timer(0.25), t)
			bgm.set_volume_db(-50)
			yield(get_tree().create_timer(0.25), t)
			bgm.set_volume_db(-55)
			yield(get_tree().create_timer(0.25), t)
			bgm.set_volume_db(-60)
			yield(get_tree().create_timer(0.25), t)
			# 停止後にボリュームを戻す
			bgm.playing = false
			bgm.set_volume_db(0)
		else:
			bgm.playing = false

# SEコントロール
# フェードはフェードアウトのみ
func _audio_se(title, is_play, is_fade):
	if is_play && title != null:
		se.set_stream(Data.get_se(title))
		se.playing = true
	else: # stop
		if is_fade:
			se.set_volume_db(-10)
			yield(get_tree().create_timer(0.5), t)
			se.set_volume_db(-20)
			yield(get_tree().create_timer(0.5), t)
			se.set_volume_db(-30)
			yield(get_tree().create_timer(0.5), t)
			se.set_volume_db(-40)
			yield(get_tree().create_timer(0.5), t)
			se.set_volume_db(-50)
			yield(get_tree().create_timer(0.5), t)
			se.set_volume_db(-60)
			yield(get_tree().create_timer(0.5), t)
			# 停止後にボリュームを戻す
			se.playing = false
			se.set_volume_db(0)
		else:
			se.playing = false
