extends "res://Scripts/StoryLib.gd"

onready var debug_label : = $DebugLabel
onready var copylight_label : = $CopylightLabel
onready var buttons_page1 : = $ButtonsPage1
onready var button2 : = $ButtonsPage1/Button2

# 1.1.0
onready var buttons_page2 : = $ButtonsPage2
onready var page2_button1 : = $ButtonsPage2/Button
onready var page2_button2 : = $ButtonsPage2/Button2
onready var page2_button3 : = $ButtonsPage2/Button3
onready var page2_description1 : = $ButtonsPage2/Description
onready var page2_description2 : = $ButtonsPage2/Description2

onready var mask : = $Mask
onready var anim : = $AnimationPlayer

func _ready():
	### debug mode
	if is_story_debug_mode:
		debug_label.show()
	else:
		debug_label.hide()
	
	buttons_page2.hide()
	
	# 著作権とバージョンの情報
	copylight_label.set_text("©Developer, Version" + app_version)
	# 音が再生されない現象を回避するために、BGMを一旦止める
	Data.emit_signal("audio_bgm", null, false, false)
	# BGMの再生(bgm1をDataに登録した任意の曲に変更可能)
	Data.emit_signal("audio_bgm", "bgm1", true, false)
	
	anim.play("fadein")
	
	mask.show()
	buttons_page1.show()
	button2.show()

func new_game():
	Data.current_story = "opening"
	Data.emit_signal("audio_bgm", null, false, false)
	anim.play("fadeout")
	yield(get_tree().create_timer(1.0), "timeout")
	Data.emit_signal("node", "story", true)
	queue_free()

func load_game():
	load_save() # セーブデータ読み込み
	Data.current_story = get_temporary("location")
	Data.emit_signal("audio_bgm", null, false, false)
	anim.play("fadeout")
	yield(get_tree().create_timer(1.0), "timeout")
	Data.emit_signal("node", "story", true)
	queue_free()

# 以下、1.1.0
func save_management_menu():
	buttons_page2.show()
	activate(page2_button1, false)
	activate(page2_button2, true)
	activate(page2_button3, false)
	
	if bool_find_file("save", save_file_name):
		activate(page2_button1, true)
		activate(page2_button3, true)

func copy_save():
	if bool_find_file("save", save_file_name):
		mask.show()
		get_read("save_copy", save_file_name)
		var temp_description = page2_description1.get_text()
		page2_description1.set_text("クリップボードにコピーしました。")
		yield(get_tree().create_timer(2.0), t)
		page2_description1.set_text(temp_description)
		mask.hide()

func takeover_save():
	if check_taken_over_save(saves(), OS.get_clipboard()):
		clear_save()
		write(save_file_name, taken_over_saves)
		temporary_saves = taken_over_saves
		_ready()
	else:
		mask.show()
		var temp_description = page2_description2.get_text()
		page2_description2.set_text("無効なデータです。")
		yield(get_tree().create_timer(2.0), t)
		page2_description2.set_text(temp_description)
		#activate(page2_button2, false)
		mask.hide()

func clear_savedata():
	clear_save()
	_ready()

func show_main_page():
	buttons_page2.hide()

func activate(button_node, is_activate):
	if is_activate:
		button_node.set_modulate(Color(1, 1, 1, 1))
		button_node.disabled = false
	else:
		button_node.set_modulate(Color("898989"))
		button_node.disabled = true
